require "import"
import "android.media.AudioManager"
import "android.content.Context"
import "android.provider.Settings"
import "android.content.ComponentName"
import "android.content.Context"
import "android.content.Intent"
import "android.widget.Button"
import "android.widget.LinearLayout"
import "android.widget.SeekBar"
import "android.widget.TextView"
import "com.androlua.LuaDialog"
import "android.app.NotificationManager"
import "android.os.Build"

context = activity or service
audioManager = context.getSystemService(Context.AUDIO_SERVICE)
notificationManager = context.getSystemService(Context.NOTIFICATION_SERVICE)

function getPhoneMode()
  local mode = audioManager.getRingerMode()
  if mode == AudioManager.RINGER_MODE_SILENT then
    return "Silent"
  elseif mode == AudioManager.RINGER_MODE_VIBRATE then
    return "Vibrate"
  elseif mode == AudioManager.RINGER_MODE_NORMAL then
    return "Ringer"
  else
    return "Unknown"
  end
end

function setVolume(streamType, progress)
  audioManager.setStreamVolume(streamType, progress, 0)
end

function setSoundMode(mode)
  local currentMode = audioManager.getRingerMode()
  if mode == "vibrate" and currentMode ~= AudioManager.RINGER_MODE_VIBRATE then
    audioManager.setRingerMode(AudioManager.RINGER_MODE_VIBRATE)
  elseif mode == "ring" and currentMode ~= AudioManager.RINGER_MODE_NORMAL then
    audioManager.setRingerMode(AudioManager.RINGER_MODE_NORMAL)
  elseif currentMode == AudioManager.RINGER_MODE_SILENT then
    print("The device is currently in silent mode.")
  end
end

function initializeSeekBar(seekBar, streamType)
  local maxVolume = audioManager.getStreamMaxVolume(streamType)
  local currentVolume = audioManager.getStreamVolume(streamType)

  seekBar.setMax(maxVolume)
  seekBar.setProgress(currentVolume)

  seekBar.setOnSeekBarChangeListener(luajava.createProxy("android.widget.SeekBar$OnSeekBarChangeListener", {
    onProgressChanged = function(seekBar, progress, fromUser)
      if fromUser then
        setVolume(streamType, progress)
      end
    end,
    onStartTrackingTouch = function(seekBar) end,
    onStopTrackingTouch = function(seekBar) end,
  }))
end

  local currentMode = audioManager.getRingerMode()
  if currentMode == AudioManager.RINGER_MODE_NORMAL then
    setSoundMode("vibrate")
    service.postSpeak(500, "Telepon Bergetar")
  elseif currentMode == AudioManager.RINGER_MODE_VIBRATE then
    audioManager.setRingerMode(AudioManager.RINGER_MODE_SILENT)
    disableVibration()
    service.postSpeak(500, "Telepon Hening")
  elseif currentMode == AudioManager.RINGER_MODE_SILENT then
    setSoundMode("ring")
    enableVibration()
    service.playSoundTick()
    service.postSpeak(500, "Telepon Berdering")

end
function disableVibration()
  if Build.VERSION.SDK_INT >= Build.VERSION_CODES.M then
    notificationManager.setInterruptionFilter(NotificationManager.INTERRUPTION_FILTER_NONE)
  end
end

function enableVibration()
  if Build.VERSION.SDK_INT >= Build.VERSION_CODES.M then
    notificationManager.setInterruptionFilter(NotificationManager.INTERRUPTION_FILTER_ALL)
  end
end